
#include<iostream>
#include<fstream>
#include<cstdlib>
using namespace std;

#include"defo.h"
#include"faq.h"

int read_logical()
{
  int ret;
  cin >> ret;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  if(ret !=1) ret=0;
  return ret;
}


int howmanydiagcoord(int dim)
{
  int ret;
  cout << "the number of coordinates in diagonalization (<= " << dim << ")" ;
  cin >> ret;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  return ret;
}



int what_num_unstb_dir()
{
  cout << "enter the number of unstable directions (0 or 1) " ;
  int ret;
  cin >> ret;
 #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  return ret;
}



int num_iter_hsets()
{
  int ret;
  cout << "number of iterates in the construction of h-sets=" ;
  cin >> ret;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  if(ret<1) ret=1;
  return ret;
}


int askUseC0intersection()
{
  cout << "Use intersection with rough estimates for dissipative coord (1/0) ";
  return read_logical();
}


void setupdndim(int *dndim,int *updim,int maxval)
{
  cout << "------------------------" << endl;
  cout << " give lower and upper dimensions <=" << maxval << endl;
  cout << "lower=" ;
  cin >> *dndim;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  cout << "upper=";
  cin >> *updim;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
}



int howmanydiscard()
// asks for bias - how many first entries from the file should be discarded
{
  int bias;
  cout << "how many initial points have to be discarded " ;
  cin >> bias ;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  return bias;
}



void selctype(char const infocoord[],int *c_type,int atr /*=1*/)
// c_type = CSNOAV - usual Fourier coordinates
//          CSDYNAV - dynamic coherent coordinates
//          CSGEOAV - geometric coherent coordinates

{
  cout << "----------------------------------" << endl;
  if(strlen(infocoord) >0)
    cout << infocoord << endl;

  if(atr)
    cout << "Choose the coordinates to represent attractor on section:" << endl;
  cout << CSNOAV << " - standard coordinates " << endl;
  cout << CSDYNAV << " - dyn. coherent structure coordinates" << endl;
  cout << CSGEOAV << " - geo. coherent structure coordinates" << endl;
  cin >> *c_type;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
}




void section_choice(char const section_info[],int sec_num,int *sel_section)
{
  cout << "Choose section : 1-" << sec_num  << endl;

  if(strlen(section_info) >0)
    cout << section_info << endl;
  cin >> *sel_section;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
}

int want_perpendicular_sec()
{
  cout << "do you want to use perpendicular section ? (1/0) ";
  return read_logical();
}

int savebinary(const char *info)
{
  if(strlen(info) >0)
    cout << info << "  ";
  else
    cout << "save data in the binary format ?(1/0) ";
  return read_logical();
}

int saveInTextformat(const char *info)
{
  if(strlen(info) >0)
    cout << info << "  ";
  else
    cout << "save data in the text format ?(1/0) ";
  return read_logical();
}

int askemptytail()
{
  cout << "do you want to start with an empty tail ?(1/0) ";
  return read_logical();
}



int whichiterate()
{
  int mapiter;
  cout << "which iterate " ;
  cin >> mapiter;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  return mapiter;
}

int wantintervalcomp()
{
  cout << " do you want to compute the image rigorously (Yes -1/ No-0)? ";
  return read_logical();
}

int which_searchmethod()
{
  cout << "search method: 0 - forward iteration (works for attractive orbits), 1 - Newton method ";
  return read_logical();
}



double changeh(double h)
{
  double hn;
  hn=h;
  cout << "time step h=" << h <<
          "   press 1  to change it, 0 - leave unchanged ";
  int c=read_logical();
  if(c){
    cout << "h=" ;
    cin >> hn ;
    #if defined(WIN95) && defined(KRAK)
    cout << endl;
    #endif
  }
  return(hn);
}

double changedelta(double delta)
{
  double dn;
  dn=delta;
  cout << " delta=" << dn <<
          "   press 1  to change it, 0 - leave unchanged ";
  int c=read_logical();
  if(c){
    cout << "delta=" ;
    cin >> dn ;
    #if defined(WIN95) && defined(KRAK)
    cout << endl;
    #endif
  }
  return(dn);
}


int changeorder(int order)
{
  int nord;
  nord=order;
  cout << "order=" << nord << "   press 1  to change it, 0 - leave unchanged ";
  int c= read_logical();
  if(c){
    cout << "order (not larger than "<< MAX_ORDER << " )  =" ;
    cin >> nord ;
    #if defined(WIN95) && defined(KRAK)
    cout << endl;
    #endif
  }
  if(nord > MAX_ORDER){
    cout << "order should be less than or equal to MAX_ORDER=" <<
      MAX_ORDER << endl;
    #if defined(WIN95) && defined(KRAK)
    waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  return(nord);
}

void inittabconstdelta(double delta[],int dim)
 // we set delta[i]=d;  for i=1,\dots,dim
 //    d - is from cin
{
  double d;
  cout << "delta[1]=  " ;
  cin >> d;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif

  delta[1]=fabs(d);
  for(int i=2;i<=dim;i++)
    delta[i]=delta[i-1];
}


void inittabdelta(double delta[],int dim)
{
  int expdecay;
  cout << "defining delta[i],   i=1,..," << dim << endl;
  cout << "press 1 - for exponential decay, 0 - delta[i]=const " ;
  expdecay=read_logical();

  if(expdecay){
    double q;
    int k;
    cout << "delta[i]= d*q^(i-k) for i>=k " << endl;
    cout << "enter k = " ;
    cin >> k;
    #if defined(WIN95) && defined(KRAK)
    cout << endl;
    #endif
    if(k<2) k=1;
    for(int i=1;i<=k;i++){
      cout << "delta[" << i << "]=" ;
      cin >> delta[i];
      #if defined(WIN95) && defined(KRAK)
      cout << endl;
      #endif
      delta[i]=fabs(delta[i]);
    }
    cout << "enter q = " ;
    cin >> q;
    #if defined(WIN95) && defined(KRAK)
    cout << endl;
    #endif
    q=fabs(q);

    for(int i=k+1;i<=dim;i++)
      delta[i]=q*delta[i-1];

  }else{
    inittabconstdelta(delta,dim);
  }
}


int do_cone_conditions()
{
  cout << "after successful check of cov. rel. verify also the cone conditions (1/0) ";
  return read_logical();
}

bool ask_recompute_inverse()
{
  cout << "do you want to recompute the inverse coordinate transformation (1/0) ";
  return read_logical();
}

int ask_about_merging()
{
  cout << "do you want to perform merging of added chain with the connection (1/0) " ;
  return read_logical();
}

int ask_dimension(int dimUpperBound)
{
  int dim;
  cout << "Enter dim  (<= " << dimUpperBound << " )=";
  cin >> dim;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  if(dim > MAX_DIM){
    cout << "Too big dimension " << endl;
    #if defined(WIN95) && defined(KRAK)
       cout << "press any key " << endl;
       waitBt();
    #endif
  }
  return dim;
}
