#include<iostream>
#include<fstream>
using namespace std;

#include"defo.h"
#include"zdynsys.h"
#include"zglstr.h"
#include"multiint.h"
#include"zgfiles.h"
#include"func.h"
#include"metnum.h"
#include"fnames.h"
#include"fileode.h"





const int odetrajtype=1;        // records  x
const int odevartrajtype=2;     // record x,df
const int odevectfieldstype=3;  //  record x,sec,vect[1]..vect[..],
                                //  + eventually factor[1]..factor[..], see top
                                // fileode.h for more detailed description

int zgleof(FILE *f)
// my feof - function
// standard feof - returns 1 when during reading we meet EOF
// my function test if in the next reading I will get EOF
//  this is what I need in various loops reading lists of vectors etc
{
  int c=getc(f);
  ungetc(c,f);
  int ret=(c==EOF);
  return(ret);

}


void erasefile(const char fname[] )
{
/*  FILE *f;
  f=fopen(fname,"w+b");
  fclose(f); */
  remove(fname);
}


int changesamplingstep(int step)
{
  int stepn;
  stepn=step;
  cout << "sampling rate in terms of time steps=" << step <<
       "   press 1 if you want to change it ";
  int c;
  cin >> c;
  #if defined(WIN95) && defined(KRAK)
  cout << endl;
  #endif
  if(c){
    cout << "step=" ;
    cin >> stepn ;
    #if defined(WIN95) && defined(KRAK)
     cout << endl;
    #endif
  }
  return(stepn);
}




int saveheader(FILE *fbin,header_of_data_type *header)
// function writes the header of traj data to binary file <fbin>
{
  fwrite(&(header->type),sizeof(int),1,fbin);
  if((header->type==odetrajtype)||(header->type==odevartrajtype) ||
    (header->type==odevectfieldstype) ){
    fwrite(&(header->dim),sizeof(int),1,fbin);
    fwrite(&(header->h),sizeof(double),1,fbin);
    fwrite(&(header->method),sizeof(int),1,fbin);
    fwrite(&(header->order),sizeof(int),1,fbin);
    fwrite(&(header->step),sizeof(int),1,fbin);
    fwrite(&(header->tmax),sizeof(double),1,fbin);
    fwrite(&(header->poincmap),sizeof(int),1,fbin);
    fwrite(header->sec,sizeof(double),header->dim+1,fbin);
  }
  if(header->type==odevectfieldstype){
    fwrite(&(header->num_vect_fields),sizeof(int),1,fbin);
    fwrite(&(header->multipliers),sizeof(int),1,fbin);
  }
  return(1);
}


int saveheader(ofstream &report,header_of_data_type *header)
// function writes the header of traj data to  text file <report>
{
  report << header->type << "  type of file ode-trajectory " << endl;
  if((header->type==odetrajtype)||(header->type==odevartrajtype) ||
     (header->type==odevectfieldstype)){
    report << header->dim << "  dimension " << endl;
    report << header->h  << "   h " << endl;
    report << header->method << "   method " << endl;
    report << header->order  << "   order " << endl;
    report << header->step << "   step - the rate at which traj. is sampled " << endl;
    report << header->tmax << "   tmax" << endl;
    report << header->poincmap << "   poincmap " << endl;
    if(header->poincmap){
      for(int i=0;i<=header->dim;i++)
        report << header->sec[i] << "    " ;
      report << "  section " ;
    } else {
      report << "no section " ;
    }
    report << endl;
  }
  if(header->type==odevectfieldstype){
    report << header->num_vect_fields << " the number of vect fields " << endl;
    report << header->multipliers << "   "<<
      ((header->multipliers)?"with multipliers":"no multipliers") << endl;
  }
  return(1);
}



int readheader(FILE *fbin,header_of_data_type *header)
{
  int ok=0;
  fread(&(header->type),sizeof(int),1,fbin);
  if((header->type==odetrajtype)||(header->type==odevartrajtype)||
    (header->type==odevectfieldstype)){
    ok=1;
    fread(&(header->dim),sizeof(int),1,fbin);
    fread(&(header->h),sizeof(double),1,fbin);
    fread(&(header->method),sizeof(int),1,fbin);
    fread(&(header->order),sizeof(int),1,fbin);
    fread(&(header->step),sizeof(int),1,fbin);
    fread(&(header->tmax),sizeof(double),1,fbin);
    fread(&(header->poincmap),sizeof(int),1,fbin);

    if(header->dim > MAX_DIM){
      cerr << "dim to big (> MAX_DIM=" << MAX_DIM << ") to read section " << endl;
      ok=0;
    }
    if(ok){
      fread(header->sec,sizeof(double),header->dim+1,fbin);
    } else{
      double trash;
      for(int i=0;i<=header->dim;i++)
        fread(&trash,sizeof(double),1,fbin);
    }
  }
  if(header->type==odevectfieldstype){
    fread(&(header->num_vect_fields),sizeof(int),1,fbin);
    fread(&(header->multipliers),sizeof(int),1,fbin);
  }
  return(ok);
}


int readheader(ifstream &ftext,header_of_data_type *header)
{
  int ok=0;
  char trash[240];
  ftext >> header->type;
  ftext.getline(trash,240);
  if((header->type==odetrajtype)||(header->type==odevartrajtype) ||
       (header->type==odevectfieldstype)){
    ok=1;
    ftext >> header->dim;
    ftext.getline(trash,240); // to eat endl
    ftext >> header->h;
    ftext.getline(trash,240); // to eat endl
    ftext >>header->method;
    ftext.getline(trash,240); // to eat endl
    ftext >>header->order;
    ftext.getline(trash,240); // to eat endl
    ftext >>header->step;
    ftext.getline(trash,240); // to eat endl
    ftext >>header->tmax;
    ftext.getline(trash,240); // to eat endl
    ftext >>header->poincmap;
    ftext.getline(trash,240); // to eat endl

    if(header->dim > MAX_DIM){
      cerr << "dim to big (> MAX_DIM=" << MAX_DIM << ") to read section " << endl;
      ok=0;
    }
    if(ok){
      for(int i=0;i<=header->dim;i++)
        ftext >> header->sec[i];
    } else {
      double t;
      for(int i=0;i<=header->dim;i++)
        ftext >> t;
    }
    ftext.getline(trash,240); // to eat endl
  }
  if(ok && (header->type==odevectfieldstype)){
    ftext>> header->num_vect_fields;
    ftext.getline(trash,240); // to eat endl
    ftext>> header->multipliers;
    ftext.getline(trash,240); // to eat endl
  }


  return(ok);
}

int readheader(const char filename[],int bin,header_of_data_type *header)
// the header is read from <filename>
// if bin - then <filename> is binary, otherwise the file is text
//// RETURN : 1 - when the header was read
///           0 - otherwise
{
  int ok;
  FILE *fbin;
  ifstream ftext;
  if(bin){
    fbin=fopen(filename,"r+b");
    ok=(fbin!=NULL);
  } else{
    ftext.open(filename);
    ok=(ftext!=NULL);
  }
  if(!ok){
    cerr << "cannot open the file ["<< filename<< "] "<< endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    return 0;
  }

  if(bin)
    ok=readheader(fbin,header);
  else  ok=readheader(ftext,header);

  if(bin) fclose(fbin);
  else ftext.close();


  return(ok);
}




void convertbinheader(const char *binfile,const char *headerfile)
{
  FILE *fbin;
  ofstream ftext(headerfile);
  fbin=fopen(binfile,"r+b");
  int  ok=(fbin!=NULL);
  if(!ok){
    cerr << "cannot open the file ["<< binfile<< "] "<< endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    return;
  }
  header_of_data_type param;

  readheader(fbin,&param);

  saveheader(ftext,&param);
  fclose(fbin);
}





int readrecord(FILE *fbin,header_of_data_type param,double x[],double sec[],
    double vect[][MAX_DIM+1],double factors[])
// depending on param.type
//  <vect> is either - Df or list of vectors
//  factors - are used only for  param.type==odevectfieldstype
//                                  param.multipliers==1
//  <factors[i]> - is a multiplier for the i-th vector field
{
  int ok=1;
  if(fread(x+1,sizeof(double),param.dim,fbin)<param.dim){
    ok=0;
    cerr << "readrecord - cannot read x " << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
  }
  if(ok){
    if(param.type==odevectfieldstype){
      if(fread(sec,sizeof(double),param.dim+1,fbin)<param.dim+1){
        ok=0;
        cerr << "readrecord - cannot read sec " << endl;
        #if defined(WIN95) && defined(KRAK)
          waitBt();
        #endif
      }
    }
  }
  if(ok){
    int vectnum=0;
    if(param.type==odevectfieldstype) vectnum=param.num_vect_fields;
    if(param.type==odevartrajtype) vectnum=param.dim;
    if(vectnum > 0){
      int vno=1;
      while((vno <=vectnum) && ok){
        if(fread(vect[vno]+1,sizeof(double),param.dim,fbin)<param.dim){
          ok=0;
          cerr << "readrecord - cannot read vec[" << vno << "]" << endl;
          #if defined(WIN95) && defined(KRAK)
            waitBt();
          #endif
        }
        vno++;
      }
    }
  }
  if(ok && (param.type==odevectfieldstype) && param.multipliers){
    int vectnum=param.num_vect_fields;
    if(fread(factors+1,sizeof(double),vectnum,fbin) < vectnum){
      ok=0;
      cerr << "readrecord - cannot read multipliers" << endl;
      #if defined(WIN95) && defined(KRAK)
        waitBt();
      #endif
    }
  }
  return(ok);
}


int readrecord(FILE *fbin,header_of_data_type param,double x[])
{
  double sec[MAX_DIM+1],vect[MAX_DIM+1][MAX_DIM+1],multipliers[MAX_DIM+1];
  return readrecord(fbin,param,x,sec,vect,multipliers);
}

int readrecord(FILE *fbin,header_of_data_type param,double x[],
  double dp[][MAX_DIM+1])
{
  double sec[MAX_DIM+1],multipliers[MAX_DIM+1];
  return readrecord(fbin,param,x,sec,dp,multipliers);
}




int readrecord(ifstream &ftext,header_of_data_type param,double x[],double sec[],
    double vect[][MAX_DIM+1],double factors[])
// depending on param.type
//  vect is either - Df
//   or list of vectors
//  factors - are used only for  param.type==odevectfieldstype
//                                  param.multipliers==1
{
  int ok=1;
  char trash[240];

  for(int i=1;i<=param.dim;i++)
    ftext >> x[i];
  ftext.getline(trash,240);

  if(param.type==odevectfieldstype){
    for(int i=0;i<=param.dim;i++)
      ftext >> sec[i];
    ftext.getline(trash,240);
  }


  int vectnum=0;
  if(param.type==odevectfieldstype) vectnum=param.num_vect_fields;
  if(param.type==odevartrajtype) vectnum=param.dim;
  if(vectnum > 0){
    int vno=1;
    while((vno <=vectnum) && ok){

      for(int i=1;i<=param.dim;i++)
        ftext >> vect[vno][i];

      ftext.getline(trash,240);
      vno++;
    }
  }

  if(ok && (param.type==odevectfieldstype) && param.multipliers){
    int vectnum=param.num_vect_fields;
    for(int i=1;i<=vectnum;i++)
      ftext >> factors[i];
    ftext.getline(trash,240);
  }

  return(ok);
}

int readrecord(ifstream &ftext,header_of_data_type param,double x[])
{
  double sec[MAX_DIM+1],vect[MAX_DIM+1][MAX_DIM+1],multipliers[MAX_DIM+1];
  return readrecord(ftext,param,x,sec,vect,multipliers);
}


int readrecord(ifstream &ftext,header_of_data_type param,double x[],
    double dp[][MAX_DIM+1])
{
  double sec[MAX_DIM+1],multipliers[MAX_DIM+1];
  return readrecord(ftext,param,x,sec,dp,multipliers);
}


void savetrajvar(Ode &ode,int calcvar,double xs[],double h,int method,int order,
   int step,  double tmax,int poincmap,double sec[],const char* fname,int bin)
// function saves to the file <fname> the trajectory of <xs>
// <ode>-differential equation
// if<poincmap> then we trajectory ends when <sec> is reached in <UP> direction
//   or the time > tmax
// if<!poincmap> then the trajectory up to time tmax is saved
// <step> - trajectory is save for time-steps being multiplies of <step>
// if<bin> - then we use binary file otherwise text file is used
//////////////////////////
// in file we have :
//  dim,h,method,order,step,tmax,poincmap,sec
//  and the points from trajectory (p_i), and D\varphi(t_poinc(p_i),*)(p_i)
//  between consequtive times
{


  FILE *fbin;
  ofstream ftext;
  int ok;
  if(bin){
    fbin=fopen(fname,"w+b");
    ok=(fbin!=NULL);
  } else{
    ftext.open(fname);
    ok=(ftext!=NULL);
  }
  if(!ok){
    cerr << "cannot open the file ["<< fname<< "] "<< endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    return;
  }

  // writting header
  int type;
  if(calcvar)  type=odevartrajtype;
  else type=odetrajtype;

  header_of_data_type header;
  header.type=type;
  header.dim=ode.dim;
  header.h=h;
  header.method=method;
  header.order=order;
  header.step=step;
  header.tmax=tmax;
  header.poincmap=poincmap;
  for(int i=0;i<=ode.dim;i++)
    header.sec[i]=poincmap?sec[i]:0.0;

  if(bin){
    saveheader(fbin,&header);
  } else {
    saveheader(ftext,&header);
  }

  // computing and saving trajectory
  double tPoinc;
  int secdir=UP;
  estimates estm;


  double rem[MAX_DIM+1];
  double xn[MAX_DIM+1],x[MAX_DIM+1];
  double xb[MAX_DIM+1]; // this is an 'x'-which starts new segment of trajectory

  double secold,secnew;
  double PoincVal[MAX_DIM+1];
  double dx[MAX_DIM+1][MAX_DIM+1],dxn[MAX_DIM+1][MAX_DIM+1];


  for(int i=1; i <= ode.dim; i++){
    x[i]=xs[i];
    xb[i]=xs[i];
  }

  if(calcvar)
    identity(dx,ode.dim);

  int ordervar=2;  // order for variational equation


  if (method==RUNGEKUTTA)
    order=4;

  if(poincmap){
    secnew=scprod(x,sec,ode.dim) + sec[0];
    secold=secnew;
  }

  initestm(&estm,ode.dim);
  UpdateBounds(x,&estm,1);

  int stepno=1;
  int poincfound=0;
  int firststep=1;
  double t=0;
  while((t<=tmax) && (!poincfound)){
    if(stepno % step==0){
      if(bin){
        fwrite(xb+1,sizeof(double),ode.dim,fbin);
        if(calcvar){
          for(int i=1;i<=ode.dim;i++)
            fwrite(dx[i]+1,sizeof(double),ode.dim,fbin);
        }
      } else{
        saveAllCoord(ftext,xb,ode.dim);
        if(calcvar){
          for(int i=1;i<=ode.dim;i++)
            saveAllCoord(ftext,dx[i],ode.dim);
        }
      }
      copyvector(x,xb,ode.dim); // xb=x
                              // this is a starting vector for the next segment
                              // of the trajectory
      if(calcvar)
        identity(dx,ode.dim);

    }


    if (method==TAYLORM) taylor(ode,order,h,x,xn,0,rem);
    if (method==RUNGEKUTTA) rk4(ode,h,x,xn);
    // to calulate xn=\varphi(h,x)
    ode.adjustenergy(xn);

    if(calcvar)  OneStepVar(ode,h,x,dx,dxn,ode.dim,ordervar);

    if(poincmap){
      secnew=scprod(xn,sec,ode.dim)+sec[0];
      if (!firststep){
        poincfound=(secdir==UP)?((secold <=0) && (secnew > 0)):((secold >0) && (secnew <= 0));
        if(poincfound){
          double coeff;
          coeff=-secnew/(secold-secnew);
          for(int i=1;i<=ode.dim; i++)
            PoincVal[i]=coeff*x[i] + (1.0-coeff)*xn[i];
          if(calcvar)  OneStepVar(ode,(1.0-coeff)*h,x,dx,dxn,ode.dim,ordervar);

          tPoinc=t + (1-coeff)*h;
        }
      }
      secold=secnew;
    }
    for(int i=1; i <= ode.dim; i++) x[i]=xn[i];
    if(calcvar) copymatrix(dxn,dx,ode.dim); // dx=dxn

    firststep=0;
    t+=h;
    UpdateBounds(xn,&estm,0);
    stepno++;
  }
  if (poincfound){
    if(bin){
      fwrite(xb+1,sizeof(double),ode.dim,fbin);
      if(calcvar){
        for(int i=1;i<=ode.dim;i++)
          fwrite(dx[i]+1,sizeof(double),ode.dim,fbin);
      }
    } else{
      saveAllCoord(ftext,xb,ode.dim);
      if(calcvar){
        for(int i=1;i<=ode.dim;i++)
          saveAllCoord(ftext,dx[i],ode.dim);
      }
    }
    if(bin){
      ode.adjustenergy(PoincVal,sec);
      identity(dx,ode.dim);
      fwrite(PoincVal+1,sizeof(double),ode.dim,fbin);
      if(calcvar){
        for(int i=1;i<=ode.dim;i++)
          fwrite(dx[i]+1,sizeof(double),ode.dim,fbin);
      }
    } else{
      saveAllCoord(ftext,PoincVal,ode.dim);
      if(calcvar){
        for(int i=1;i<=ode.dim;i++)
          saveAllCoord(ftext,dx[i],ode.dim);
      }
    }
  }
  // end of computing trajectory


  if(bin){
    fclose(fbin);
  } else{
    ftext.close();
  }
}



char *trajfname(const char* odedescription,char* fname,int maxlenfname,
                          int pno,int bin,int type,int workfile)
// pno - for example the point number, or some other integer used to
//       differentiate trajectories
// possible values of type - odetrajtype=1;
//            odevartrajtype=2;
//             odevectfieldstype=3;
{
  char buffer[80];
  int buflen=80;
  char lfname[120];
  int lenfname;
  if(workfile)
    strcpy(lfname,catwork);
  else
    strcpy(lfname,goodcatname(buffer,odedescription,buflen));

  char shname[20];
  strcat(lfname,shortname(shname,odedescription));
  strcat(lfname,itoa(pno,buffer,10));
  if(type==odevartrajtype)  strcat(lfname,"df");
  if(type==odevectfieldstype) strcat(lfname,"iv");
  if(bin){
    strcat(lfname,binorbext);
  } else{
    strcat(lfname,orbext);
  }
  if(strlen(lfname) < maxlenfname){
    strcpy(fname,lfname);
  }
  return fname;
}






void saveodepoinctraj(Ode &ode,double h,double sec[],double xs[],double tmax,
    int pno, char *fname,int maxlenfname,int *bin,int withdf  /*=-1 */)
// this function compute and saves the trajectory for the Poincare map
//  defined by <ode>  and <sec>
// it is assumed that the section is UP
//  h - time step
// xs - starting point
// tmax - the maximum return time allowed
// pno - the number used to differentiate points - just to produce different
//       file names
// withdf - -1 computer will ask the question if we want to save jAcobian
//           matrix of the flow
//           0 - the Jacobian matrix is not save with the trajectory
//           1 - the Jacobian matrix is saved with trajectory (necessary)
//              if we want to use <fname> as the basis for construction of
//              invariant vector fields
//  maxlenfname - the length (the size of fname[]) of the variable fname
//
// On output
//  <fname> - is the name of the saved trajectory
//  bin - tells if the file <fname> is binary

{
  int method=RUNGEKUTTA;
  int order=4;
  int step=2; // it is reasonable to have the step bigger then 1
      // for example when constructing segments I have problems for Poinacre
      // map, which can be realized during first step
  int poincmap=1;


  step=changesamplingstep(step);

  cout << "Trajectory in : 1 - binary file, 0 - text file: " ;
  cin >> *bin ;
  if((*bin)!=1) *bin=0;
  cout << ((*bin)?"binary":"text") << endl;
  if(withdf==-1){
    cout << "Press: 1 - with df 0 - otherwise ";
    cin >> withdf;
  }
  if(withdf!=1) withdf=0;
  cout << (withdf?"with df":"trajectory only") << endl;

  int workfile=1;
  int type=withdf?odevartrajtype:odetrajtype;
  trajfname(ode.infostr,fname,maxlenfname,pno,*bin,type,workfile);


  savetrajvar(ode,withdf,xs,h,method,order,step,tmax,poincmap,sec,fname,*bin);

  cout << "the trajectory is saved to [" << fname << "]" << endl;
  #if defined(WIN95) && defined(KRAK)
    cout << "press any key " << endl;
    waitBt();
  #endif
}






