#include<iostream>
#include<cstdlib>
using namespace std;


#include"defo.h"
#include"zglstr.h"
#include"fnames.h"



const char *pointer_to_extension(const char *fname)
//  a pointer to the  extension  <filename> is is returned (it points to "." in
//    <fname>)
// if there is not extension, then NULL is returned
{
  const char *p;
  int isext=0;
  p=strchr(fname,'.');
  if(p){
    while(strchr(p+1,'.'))
      p=strchr(p+1,'.');
  }
  if(p){
    isext=1;
    // we have to check whether this dot "." is not a part of the directory name
    const char *p2;
    p2=strchr(p,'\\');
    if(!p2) p2=strchr(p,'/');
    if(p2) isext=0;
  }
  if(!isext) p=NULL;
  return p;
}


const char *pointer_to_fn_nodir(const char *fname)
//  a pointer to the 'filename part' in <fname> is is returned - the pointer
//  fname=path + propername - pointer points to proper name
{
  const char *p1; // it will point to the last occurence of '\\'
  p1=strchr(fname,'\\');
  if(p1){
    while(strchr(p1+1,'\\'))
      p1=strchr(p1+1,'\\');
  }

  const char *p2; // it will point to the last occurence of '/'
  p2=strchr(fname,'/');
  if(p2){
    while(strchr(p2+1,'/'))
      p2=strchr(p2+1,'/');
  }

  const char *ret;
  if(p1==NULL) p1=p2;
  if(p2==NULL) p2=p1;

  if(p1==NULL) ret=fname;
  else{
    if(p1 > p2) ret=p1;
    else ret=p2;
    ret=ret+1;
  }


  return ret;
}


char *createwrkname(char *buffer,int buflen,const char fname[])
// returns buffer=catwork +  the proper name of <fname>
{
  const char *p=pointer_to_fn_nodir(fname);
  if(strlen(catwork)+strlen(p) < buflen){
    strcpy(buffer,catwork);
    strcat(buffer,p);
  }
  return buffer;
}



char *addext(char *filename,int maxlen,const char *inname,const char *ext)
 // we assume that <ext> - has the form ".*"
{
  int add=1;
  char *fname;
  int fnamesize=strlen(inname) + strlen(ext)+2;
  fname=new char[fnamesize];
  strcpy(fname,inname);
  char *p;
  p=(char *)pointer_to_extension(fname);
  if(p !=NULL) add=0;
  if(add) strcat(fname,ext);



  strcpy(filename,"");
  strncpy(filename,fname,maxlen);

  delete [] fname;

  return filename;
}

char *delextension(char *fname)
  // the function remove the extension fron <fname>
  // we assume that extension  has the form ".*"
{
  int isext=0;
  char *p=(char *)pointer_to_extension(fname);
  if(p !=NULL) isext=1;
  if(isext){ // we have to remove the old extension
    *p='\0';
  }
  return(fname);
}


char *newext(char *fname,int maxlen,const char *inname,const char *ext)
  // the function replaces an old extension in <inname> by <ext>
  // the result is send to <fname>
  // we assume that <ext> - has the form ".*"
{
  strcpy(fname,inname);
  delextension(fname);
  if(strlen(fname)+strlen(ext)< maxlen){
    strcat(fname,ext);
  }
  return(fname);
}






char *extension(char *ext,const char *fn)
  // the function returns the extension in <fn>
  // the result is send to <ext>
  // we assume that <ext> - has the form ".*"
  //  dot is also returned
{
  strcpy(ext,"");
  char fname[80];
  strcpy(fname,fn);
  int isext=0;
  char *p;
  p=(char *)pointer_to_extension(fname);
  if(p !=NULL) isext=1;
  if(isext){
    char *p3;
    p3=ext;
    *p3=*p; // the dot is copied
    do{
      p++;
      p3++;
      *p3=*p;
    } while (*p!='\0');
  }
  return(ext);
}




char *cvbinproof_fname(char *fnamebin,int workdir,const char *odeinfostr)
// returns the name of the file for the binary file with h-sets and Poincare maps
//  from the proof of covering relations
{
  int buflen=80;
  char sname[20];
  if(workdir)
    strcpy(fnamebin,catwork);
  else
    goodcatname(fnamebin,odeinfostr,buflen);

  strcat(fnamebin,shortname(sname,odeinfostr));
  strcat(fnamebin,"chn");
  strcat(fnamebin,binorbext);

  return fnamebin;
}

char *secbinfname(char *secfilename,int workdir,const char *odeinfostr)
// returns the name of the file for the binary file with sections - this
// might be used in the cov. rel. proofs
{
  int buflen=80;
  char sname[20];
  if(workdir)
    strcpy(secfilename,catwork);
  else
    goodcatname(secfilename,odeinfostr,buflen);

  strcat(secfilename,shortname(sname,odeinfostr));
  strcat(secfilename,"sec");
  strcat(secfilename,binorbext);
  return secfilename;
}

char *hcentersfilename(char *hcfilename,const char *secfilename)
//  on output in hcfilename (which is also the return value) we
//   have <secfilename> with "cen" inserted right before the extension
{
  char exten[10];
  strcpy(hcfilename,secfilename);
  extension(exten,hcfilename);
  delextension(hcfilename);
  strcat(hcfilename,"cen");
  strcat(hcfilename,exten);
  return hcfilename;
}



char *cotypetostr(char *ret,int coord_on_attr)
{
  switch(coord_on_attr){
  case CSNOAV: strcpy(ret,"n");break;  // normal coordinates
  case CSDYNAV: strcpy(ret,"d");break;  // coh. str. - dynamic
  case CSGEOAV: strcpy(ret,"g");break;  // coh. str. geometric
  }
  return ret;
}


void  buildsuff1dim(char suff1dim[],int sec_number,int section,
      int coord_on_atr,int cno_on_atr,int calc,int local /*=0*/)
  //  on output <suff1dim> contains a suffix to file name
  //   built using the following prescription
  //   "_" + section_no + coord_type_on_atrr("n","d","g") + cno_on_atr +
  //  "type of coordinates used to in calculations"(calc) +
  //  if(local,".l"+sec_number,"")
  // section_no - is included iff sec_number(number of sections) > 1
  // coord_type_on_atrr - is decided upon coord_on_atr
  // cno_on_atr - selected coordinate
{
  // section no

  strcpy(suff1dim,"_");
  if(sec_number>0){
    char stris[5];
    itoa(section,stris,10);
    strcat(suff1dim,stris);
  }

  // coding of 1-dim coordinate describing an attractor
  char tt[2];
  strcat(suff1dim,cotypetostr(tt,coord_on_atr));

  char strc[5];
  itoa(cno_on_atr,strc,10);
  strcat(suff1dim,strc);
  //  end of coding of 1-dim coordinate describing an attractor

  // coding of how calculations are performed
  strcat(suff1dim,cotypetostr(tt,calc));


  if(local){
    strcat(suff1dim,".l");
    char ss[3];
    itoa(sec_number,ss,10);
    strcat(suff1dim,ss);
  }

}



char *shortname(char *shname,const char odedescription[])
{
   if(strcmp(odedescription,"KURAMOTO")==0)
    strcpy(shname,"ks");

  if(strcmp(odedescription,"ROSSLER")==0)
    strcpy(shname,"ro");

  if(strcmp(odedescription,"HENONHEILES")==0)
    strcpy(shname,"hh");

 if(strcmp(odedescription,"MICHELSON")==0)
    strcpy(shname,"mi");

  if(strcmp(odedescription,"PCR3BP")==0)
    strcpy(shname,"r3b");
  return shname;
}




void P1dimfname(char filename[],int maxlenfn,const char odedescription[],int pdim,
            const char suffix[])
// On output:  filename = catwork + shortname(odedescription) + itoa(pdim) + suffix
//          if pdim <0 then <pdim> is ignored
{
  char longfn[120];

  strcpy(longfn,catwork);

  char buffer[10];
  strcat(longfn,shortname(buffer,odedescription));


//  strcat(filename,"1d");
  if(pdim >=0){
    char dimstr[5];
    itoa(pdim,dimstr,10);
    strcat(longfn,dimstr);
  }

  if(strlen(suffix)!=0){
    strcat(longfn,suffix);
  }
  strcpy(filename,"");
  strncpy(filename,longfn,maxlenfn-1);
}

void filep1dname(char name[],int maxlenname,const char infoode[],int pdim,int sec_number,
    int section,int coord_type_on_atr,int c_no_on_atr,int coord_calc,int local)
{
  char suff[20];
  buildsuff1dim(suff,sec_number,section,coord_type_on_atr,c_no_on_atr,
   coord_calc,local);
  P1dimfname(name,maxlenname,infoode,pdim,suff);
}


void CS_ep_name(char name[],int maxlenname,const char infoode[],int sec_number,int section,
    int coord_type_on_atr,int c_no_on_atr,int coord_calc)
// function to build a name of file containing report about
//  computations of chain Poincare maps with varying dimensions
//  PARAMETERS: name - on output - name of report file
//              maxlenname - the length of name[]
//              infoode - descriptor of ODE investigated
//              sec_number - number of sections
//              section - starting section
//              coord_type_on_atr - coordinates used on atractor on
//                     <section>-th section:
//                   values 1- normal(standard) coord.
//                          2 - CS - dynamical
//                          3 - CS - geometrical
//              c_no_on_atr - selected coordinate on the attractor
//              coor_calc - coordinates used in in computations
//                 values as for coord_type_on_atr
//
{
  const int buflen=20;
  char suff[buflen];
  buildsuff1dim(suff,sec_number,section,coord_type_on_atr,c_no_on_atr,
   coord_calc,1);

  char temp[buflen];
  strcpy(temp,suff);
  newext(suff,buflen,temp,orbext);

  P1dimfname(name,maxlenname,infoode,-1,suff);
}





char *goodcatname(char *name,const char odedescription[],int maxlen)
//  returns - the name of working directory for an ODE identifyied by <goodcatname>
//           maxlen - the the space (max strlen) available for the variable <name>
{
  int ok=1;
  strcpy(name,"");
  strncpy(name,catgoodd,maxlen-1);
  if(strlen(catgoodd)!=strlen(name)){
    ok=0;
  }
  if(ok){
    char shname[10];
    shortname(shname,odedescription);

    if(maxlen > strlen(name)+strlen(shname)+1){
      strcat(name,shname);
      strcat(name,"/");
    }else ok=0;
  }
  if(!ok){
    cerr << "the parameter <char *name> in <goodcatname> needs to be longer " << endl;
    #if defined(WIN95) && defined(KRAK)
    waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  return name;
}



char *suffatronsec(char *suff,int coord_on_attr,int first_coord, int sec_coord)
// this is a suffix to a file - an intersection of the atractor with the section
//    coord_on_attr - CSNOAV - standard coordinates
//    coord_on_attr - CSDYNAV, CSGEOAV - dynamic or geometric resp.
//              coherent coordinate
//    first_coord - the index of the first coordinate
//    sec_coord - the index of the second coordinate
{
  strcpy(suff,"a");
  char t[10];
  strcat(suff,cotypetostr(t,coord_on_attr));
  strcat(suff,itoa(first_coord,t,10));
  strcat(suff,"_");
  strcat(suff,itoa(sec_coord,t,10));
  return suff;
}

char *sufftsonsec(char *suff,int coord_on_attr, int coord_no)
// this is a suffix to a file containing an intersection of the atractor with the section
//    coord_on_attr - CSNOAV - standard coordinates
//    coord_on_attr - CSDYNAV or CSGEOAV - dynamic or geometric resp. coherent
  //                coordinate
//    coord_no - the coordinate used
{
  strcpy(suff,"ts");
  char t[10];
  strcat(suff,cotypetostr(t,coord_on_attr));
  strcat(suff,itoa(coord_no,t,10));
  return suff;
}




