#ifndef _ksperiso_h
#define _ksperiso_h

#include"vfkso.h"
#include"galks.h"
#include"section.h"
#include"inclpoin.h"





int genhset_from_point(ostream &/*report*/,int iter,int xdim,
         int withtail,int tailevolution,interval x[],interval fx[],
                SetWithTail &y,SetWithTail &fy,interval  xnew[],
                 SetWithTail & ynew);
// the generation of <xnew>, <ynew> new candiate set for the h-set with tail
// for the strategy  <gen_from_point>
//  xdim=dim(x)=dim(fx)=dim(xnew)
// if (iter==1) then xnew,ynew are obtained by the inflation
//             of fx and fy respectively
// if iter >0 then for each direction (both in main variables and tail)
//  if fx[i]\subset x[i], then on output we have fx[i] \subset  xnew[i] \subset x[i].
//               xnew[i] is obtained through 'intelligent' intersection
//                     of x[i] and fx[i]
///   otherwise xnew[i] is set to fx[i] inflated

int gen_hset_with_tail_cap_infl(ostream &report, int i,int iter,int xdim,
     int withtail,int tailevolution,interval x[],interval fx[],
            SetWithTail &y,SetWithTail &fy,interval  xnew[],SetWithTail & ynew);
// the generation of <xnew>, <ynew> new candiate set for the h-set with tail
// for the strategy  <gen_new_intersect>
// xdim=dim(x)=dim(fx)=dim(xnew)
// On output - 1 is always returned
// if the intersection (x \oplus y) \cap (fx \oplus fy) is nonempty ;
//     in this case <xnew> is subset of x and contains x \cap fx
//                  <ynew> is subset of y and contains y \cap fy
//  if this intersection is empty - then we shift xnew \oplus ynew
//                     is centered at center of fx \oplus fy
//          and in each direction, i, the diameter is based on some convex combination
//               diameters of x[i] and fx[i]

int corr_based_on_diameters(int mustbeinx,int xdim,int withtail,int tailevolution,
           interval x[],interval fx[],SetWithTail &y,SetWithTail &fy,
       interval  xnew[],SetWithTail & ynew);
// we make we change the candidate set taking into account
//  the sizes of fx and fy
// if withtail==0 then we ignore the tail
//   if tailevolution==0 then we set ynew=y
// dim(x)=dim(fx)=dim(xnew)=xdim
// 1 - is returned if  new guesses has been defined (in xnew and ynew)
// 0 - otherwise
//  if mustbeinx - then we make sure that on output xnew \subset x
//                                        and ynew \subset y
///////////
/// mustbeinx==1 should be used when we already have all correct inclusions
//   and we want to have new x,y which will be slightly larger that
///   x \cap fx, y\cap fy; but be still contained in x,y
//   so that the new x,y will be set on which also the inclusion from
//       Poincare map is satisfied


int kstrajfile_exist(char* traj,int maxlentraj,const char *ksinfostr,int *dimintraj);
 // return 1 if there exists the file ksinfostr + 'orbit'+orbext
  //            which currently is '../data/ks/orbit.txt'


int ks_rot13_boxes_galerrfromset(interval mu, const char* traj,double bias, int partition,
    int m,int big_m,double expcoeff,intervalmatrix1 *boxes,int *boxnum,interval galerr[],
      int num_last_coord, KuraShi_Tail *ks_tail );
//  On output: we obtain self-consistent bounds
//      boxes - the set W
//      ks_tail - the tail a^\pm_k for k > m
//      galerr[i]  - for i=1,\dots,m   the sizes of the influence of the tail
//                    onto f[i], hence Basic Differential Inclusion reads
/////////                 x[i]'=f_i[x] + galerr
//  the function uses the projection onto the plane (1,3) - which is divided
//  into <partition>-sections - using an angular coordinate



void ksinclcomp_description(ostream &report,KuraShi &kurashi,int symperorbit,
    int startsec,int partition,double expcoeff, int num_coord_iso,
    int tailevolution,int uselocgalerr,int sec_perpendicular,const double xs[],
    int numLohner);

void gal_saveinitialcond(ostream &report,const interval ixb[],const interval r0[],
                      int dim,SetWithTail &y);


void  gal_save_res(ostream &report,const interval fx[],const interval rcomp[],
   int dim,SetWithTail &fy,int writeratios);
// we write down to file fx \oplus fy.tail
// if writeratios then we additionally compare diameters of fx and rcomp

void gal_sectionDataSave(ostream &report,InclPoincareMap &InclPMap,bool useothercoord,const LinCC *coordch);
//  we save the section data from the proof of the existence of periodic orbit for Galerkin projections
//  in the text format



void  write_no_tail_inclusion(ostream &report,KuraShi_Tail *fyptail,
         KuraShi_Tail *yptail);



void ksInclPoincPar(InclPoincareParType &param,KuraShi &kurashi);
// asks (and sets) for various parameters of numerical method
//       for differential inclusion

void param_ghpp_comp(KuraShi &kurashi,int manyattempts, int tailevolution,
       int *startsec,int *sec_perpendicular,int *partition,
       double *expcoeff,int *numLohner,double delta[],int *emptytail,
       double *mindelta, double *maxdelta, int *iternum,int *set_partition,
      InclPoincareParType &param,int *coord,int *dimdiag);


void symorbit_question(int *symperorbit, int *testasymmetry);

int asymmetry_test(ofstream &report,InclPoincareMap *symPMap,interval ixb[],
    interval r0[],int numLohner,SetWithTail &y,int divtable[],int dimdiv,
    LinCC *coordch);
//  ixb + r0 - is the bound for periodic orbit
// we return true if symMap(ixb+x0 + y.ptail) \cap (ixb + r0 + y.ptail)=\emptyset


void ksinclpreparePMap(FPoincareMap **PMap,KuraShi &kurashi,int startsec,
          int symperorbit,InclPoincareParType &param);
// creates the Poincare map , if symperorbit then this is half-poincare composed
// with the reflectional symmetry

void  ksincl_createinclpmaps(Galerkin_Proj_KuraShi **inclode,
          InclPoincareMap **inclPMap,InclPoincareMap ** asymtestPMap,
          FPoincareMap *PMap, InclPoincareParType &param,KuraShi &kurashi,
          interval **galerr, intervalmatrix1 **boxes,int *boxnum,KuraShi_Tail **ks_tail,
           int big_m,int partition,double bias, double expcoeff,
           int num_coord_iso,int uselocgalerr,int tailevolution,
           int symperorbit,int testasymmetry);
// prepares inclPMap and asymtestPMap for the proofs of the existence
// of periodic orbits, parameters for these maps are given in <param> and <PMap>
// num_coord_iso;  the number of coordinates for which we 'guarantee'
              // an isolation - important when using global tail
              // otherwise it is ignored

void  ksredefine_perpend_PMap(FPoincareMap **PMap,KuraShi &kurashi,double xs[],
             double xb[],int symperorbit);
// we change the PMap to a Poincare map  on the perpendicular section
//  at xs, dim(xs)=kurashi.dim
///// On output xb - is xs - expressed in new section coordinates for **PMap
///                dim(xb)=kurashi.dim-1=*PMap->dim


void KSinclPoincareBrouwer(KuraShi &kurashi);
// an attempt of full proof in infinite dimension of the existence
//  the apparently attracting periodic orbit
// it WORKS for mu \approx 0.127, \mu=0.032, \mu=0.1215 (nonsymmetrc)
//  the attractivity is not proved, just the existence



void incl_poinc_manysizes(int testfunc(FPoincareMap &,InclPoincareMap &,
       Galerkin_Proj_KuraShi &, double [],double [],int ,SetWithTail &,ofstream &,int ,
       int , int, int, int, InclPoincareMap *),
       FPoincareMap &PMap,InclPoincareMap &inclPMap,Galerkin_Proj_KuraShi
        &inclode,int numLohner, double xb[],double  maxdelta,double mindelta,
       SetWithTail &y0, ofstream &report, int coord, int dimdiag,int iternum,
       int do_division,int testasymmetry, InclPoincareMap *symPMap);
//  checks for various sizes that the Poincare map for PDE has a fixed point (testfunc)
//
//  xb - our approximate fixed point
//  y0 - the candidate for the tail
//  maxdelta  and mindelta - bounds on the size of the sides of N
//  coord - possible values:
//         - standardcoord
//         - orthogonalizedeigenvectors;
//         - eigenvectors;
//         - eigen_subspaces_ortogonalized
//  do_division - if ==1, then starting from the second iterate the domain
//              is divided into parts for the computations
//  testasymmetry - if 1 we check if   x \cap symPMap(x)=\emptyset
//                where x the fixed point found;
//             it should be used when inclPMap - is the full Poincare map
//                     symPMap - is then half poincare
//           and the candidate orbit is nonsymmetric

 void ksPDEcomputetraj(KuraShi *pkurashi);

#endif
