#include<iostream>
#include<fstream>
using namespace std;

#include<cstdlib>

#include"defo.h"
#include"lohner.h"
#include"metnum.h"
#include"multiint.h"
#include"zdynsys.h"
#include"qrdecmp.h"
#include"zset.h"


void C1LohnerRearrangement(C1Set &V, C1Set &Vn,intervalmatrix1 *A)
// I have to be very carrefull when rewriting this function, because
// at this moment it is not obvious what data should be already on input
//  in Vn  ; because the in C1OneStepLohner we have at the begining Vn=V
{
  if(V.currnumLo==LOHNER1){
    intervalmatrix1 *Vdn;
    Vdn=new intervalmatrix1[Vn.dim+1];
    V.intvencl(Vdn);
    ArrArr(A,Vdn,Vdn,Vn.dim);  // Vdn=A*Vd
    copymatrix(Vdn,Vn.Vc,Vn.dim); // Vn.Vc=Vdn
    split(Vn.Vc,Vn.Vr,Vn.dim);
    delete [] Vdn;
  }else{
    //  the QR-decomposition
    //  the variational matrix is represented as
    //   V=Vc + Vb*Vr - for LOHNER3
    //  and V=Vc + Ve*V0 + Vb * Vr - for LOHNER5
    // for new values each variable name gets  a suffix 'n'

    // interval m[MAX_DIM+1][MAX_DIM+1];
    // interval mc[MAX_DIM+1][MAX_DIM+1];
    intervalmatrix1 *m;
    m=new intervalmatrix1[Vn.dim+1];

    intervalmatrix1 *mc;
    mc=new intervalmatrix1[Vn.dim+1];

    ArrArr(A,V.Vb,m,Vn.dim);  //  m=A*V.Vb
    mid(m,mc,Vn.dim);  // mc=mid(m)
    if(!iQRDecomp(mc,Vn.Vb,Vn.dim)){ // Vn.Vb - an orthogonal factor of mc
      cerr << "iQRDecomp returned false in   <C1LohnerRearrangement> " << endl;
      #if defined(WIN95) && defined(KRAK)
      waitBt();
      #endif
      exit(EXIT_FAILURE);
    }

    // interval Vbnt[MAX_DIM+1][MAX_DIM+1];
    intervalmatrix1 *Vbnt;
    Vbnt=new intervalmatrix1[Vn.dim+1];

    transpose(Vn.Vb,Vbnt,Vn.dim);

    ArrArr(A,V.Vc,Vn.Vc,Vn.dim);

    // interval rV[MAX_DIM+1][MAX_DIM+1]; // 'remainder'
    intervalmatrix1 *rV;
    rV=new intervalmatrix1[Vn.dim+1];
    split(Vn.Vc,rV,Vn.dim);  // now diam(Vn.Vc)=0; A*V.Vc \subset Vn.Vc + rV


    if(V.currnumLo==LOHNER5){
      // we need to update the 'Lipschitz' part and rV
      ArrArr(A,V.Ve,Vn.Ve,Vn.dim); // Vn.Ve=A*V.Ve
      // interval rVe[MAX_DIM+1][MAX_DIM+1];
      intervalmatrix1 *rVe;
      rVe=new intervalmatrix1[Vn.dim+1];
      split(Vn.Ve,rVe,Vn.dim); // now diam(Vn.Ve)=0;  A*V.Ve \subset Vn.Ve + rVe
      ArrArr(rVe,V.V0,rVe,Vn.dim); // this is the remainder form 'Lipschitz'
                                  // part
      // total remainder is rV+rVe
      for(int i=1;i<=Vn.dim;i++)
        for(int j=1;j<=Vn.dim;j++)
          rV[i][j]+=rVe[i][j];

      delete [] rVe;
    }

    ArrArr(Vbnt,rV,rV,Vn.dim); // this part from remainder in new Vn.Vr

    // to avoid wrapping we multiply as follows: (Vnbt*A*V.Vb)*V.Vr
    ArrArr(Vbnt,m,m,Vn.dim); // m=Vn.Vb^t*A*V.Vb
    ArrArr(m,V.Vr,Vn.Vr,Vn.dim); // Vn.Vr= (Vn.Vb^t*A*V.Vb)*V.Vr

    // Vrn+=rV
    for(int i=1;i<=Vn.dim;i++)
      for(int j=1;j<=Vn.dim;j++)
        Vn.Vr[i][j]+=rV[i][j];

    // now Vn.Vr= (Vn.Vb^t*A*V.Vb)*V.Vr + rV (=Vn.Vb^t*remainders)

    delete [] rV;
    delete [] Vbnt;
    delete [] mc;
    delete [] m;

  }
}


int OneStepLohner(Ode &ode,const OneStepParamType &paronestep, interval h,
       Set &x,interval xd[],Set &xn, interval xdn[],interval xencl[],
       interval rem[])
//  h - time step
// on INPUT : x  \subset xd
// on OUTPUT :
//       \varphi(h,x) \subset xn  \subset xdn
//    \varphi([0,h],x) \subset xencl
// rem; // remainder term in Taylor method, before multiplication
//         by h^(order+1)
{

  int ok=1;
  if(!MultiIn(x.xc,xd,0,x.sdim())){
    ok=0;
    cerr << "OneStepLohner - x.xc is not contained in xd, unable to continue " << endl;
    if(!x.sintersect_rep()){
      cerr << "serios error " << endl;
    }else{
      cerr << "this is not a program error in <OneStepLohner>, " << endl;
      cerr << "the initial conditions for this time step are not consistent " << endl;
    }
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    return(0);
  }

  // an estimation of the set xecnl,  \varphi([0,h],xd) \subset xencl
  ok=ode.enclosure(xd,h,xencl);
  if(!ok){
    cerr << "OneStepLohner - bad enclosure for xd " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    return(0);
  }


  //  interval A[MAX_DIM+1][MAX_DIM+1]; // matrix df_i/dx_j
  intervalmatrix1 *A;
  A=new intervalmatrix1[ode.dim+1];

  interval *xnxc;
  xnxc=new interval[ode.dim+1];

  interval dummy[MAX_DIM+1];

  if (paronestep.method==TAYLORM){
    taylor(ode,paronestep.order,h,x.xc,xnxc,0,dummy);   // to calculate xn=taylor expansion(\varphi(h,x))
    taylor(ode,paronestep.order,h,xencl,dummy,1,rem);
         // to calculate a remainder term on enclosure of \varphi([0,h],xd)
  }


  if (paronestep.method==RUNGEKUTTA){
    cerr << "Runge-Kutta not supported " << endl;
     #if defined(KRAK) && defined(WIN95)
                   waitBt();
    #endif
    exit(EXIT_FAILURE);
  }


  /* calculation of variations */
  if (paronestep.method==TAYLORM){
    intervalmatrix1 *dummyM;
    dummyM=new intervalmatrix1[ode.dim+1];
    dertaylor(ode,paronestep.order,h,xd,dummyM,dummy,A,0,dummyM);
      // to calculate A=Df(x_d) = d/dx (\diff_method(h,x)))
    delete [] dummyM;
  }

  interval hto_op1=1.0;
  for(int i=1;i<=paronestep.order+1;i++)
    hto_op1*=h;

  for(int i=1;i<=ode.dim;i++)    xnxc[i]+=rem[i]*hto_op1;


  LohnerMove(x,xnxc,A,xn);  // time-h map(x) \subset  xn

  xn.intvencl(xdn);

  if(ode.dissipative){
    interval *xstep;
    xstep=new interval[ode.dim+1];
    ode.dissOneStep(xd,h,xencl,xstep,0,NULL);
    if(paronestep.doC0intersection){
      ok=xn.intersect_interval(xstep);  // if xn.sintersect_rep() then it also
                      // does if  necessary  a rearrangment, which will guarante
                      // that <xn.xc> is in the interval enclosure  of <xn>
      xn.intvencl(xdn);
    } else{
      if(xn.sintersect_rep()){
        ok=commonpart(xstep,xn.enclo_intv,xn.enclo_intv,ode.dim);
        if(ok){
          copyvector(xn.enclo_intv,xdn,ode.dim);
          if(!xn.test_xc_in_encl(false)){ // we do the intersection of "Lohner set"
                                           // because xc in not in <xn.enclo>
            ok=xn.intersect_interval(xn.enclo_intv);
            xn.intvencl(xdn);
          }
        }
      }
    }
    if(!ok){
      char comment[]="an empty intersection of  computed bound for x(h) and rough enclosure for x(h) " ;
      cerr <<  "OneStepLohner - serious error " << endl;
      cerr << comment << endl;
      info_err_commonpart(xdn,xstep,ode.dim,comment);
      #if defined(WIN95) && defined(KRAK)
      waitBt();
      #endif
    //  exit(EXIT_FAILURE);
    }
    /*  // these are tests lines
    if(!xn.test_xc_in_encl(true)){
      cerr <<  "OneStepLohner - warning: xc is not in enclosure " << endl;
      #if defined(WIN95) && defined(KRAK)
      waitBt();
      #endif
    }
    */


    delete [] xstep;
  }

  delete [] xnxc;
  delete [] A;
  return(ok);
}


int C1OneStepLohner(Ode &ode,const OneStepParamType &param, interval h,
       Set &x,interval xd[],Set & xn, interval xdn[],interval xencl[],
       interval rem[], C1Set &V, interval /*Vd*/[][MAX_DIM+1],
       C1Set &Vn,interval Vdn[][MAX_DIM+1], interval Vencl[][MAX_DIM+1],
       interval Vrem[][MAX_DIM+1])
// one step of C1-Lohner algorithm
//  h - a time step
// on INPUT : x  \subset xd, V \subset Vd
// on OUTPUT :
//       \varphi(h,x) \subset xn  \subset xdn
//    \varphi([0,h],x) \subset xencl
//      rem - a  remainder term in Taylor method, before the multiplication
//         by h^(order+1)

//  Variational data:
//  are treated analogously:
//  param.orderdf - an order of numerical method used for variational matrix
//  On OUTPUT:
//    d/dx \varphi(t+h,x0)=V(t+h,x0) \subset Vn \subset Vdn
//    d/dx \varphi(t+[0,h],x0)=V(t+[0,h],x0) \subset Vencl=[W4] - "C^1-Lohner alg."
// IT IS NOT OBVIOUS THAT THIS IS DESIRABLE - we may want W3
//  Vrem - remainder term for the variational matrix V(h,x), before
//           the multiplication   by h^{orderV+1} (includes already
//           the multiplication  by [W3] - an enclosure for V([0,h],x))
/////////////////////////////////////
//  currently only C^1_1 - algorithm is implemented, it does not
//           coincide with C^0-Lohner algorithm on x-variables

//// when numLohner==LOHNER1 - (Lohner evaluation 1)
////// then r0,C,Cn,B,Bn - are not used , in this case
// on INPUT : x + r \subset xd
//     in fact  xd= x + r (realised in computer arithemetic)
// on OUTPUT :
//       \varphi(h,x + r) \subset xn + rn \subset xdn
//     in fact  xdn= xn + rn (realised in computer arithmetic)
//    \varphi([0,h],x + r) \subset xecnl

///// numLohner== cuboid set (QR-decomposition)
////// then r0,C,Cn - are not used , in this case
// on INPUT : x +  B*r \subset xd
//     in fact  xd= x +B*r (realised in computer arithmetic)
// on OUTPUT :
//       \varphi(h,x + B*r) \subset xn +  Bn*rn \subset xdn
//     in fact  xdn= xn +  Bn*rn (realized in computer arithmetic)
//    \varphi([0,h],x + B*r) \subset xecnl


//// numLohner==  doubleton
// on INPUT : x + C*r0 + B*r \subset xd
//     in fact  xd= x + C*r0 + B*r (realised in computer arithmetic)
// on OUTPUT :
//       \varphi(h,x + C*r0 + B*rn) \subset xn + Cn*r0 + Bn*rn \subset xdn
//     in fact  xdn= xn + Cn*r0 + Bn*rn (realised in computer arithmetic)
//    \varphi([0,h],x + C*r0 + B*rn) \subset xecnl

// rem[]; // remainder term in Taylor method, before multiplication
//         per h^(order+1)

//  Variational data:
//  are treated analogously:
//   numLohnerV - LOHNER1, LOHNER3, LOHNER5
//  orderV - order of numerical method used for variational matrix
//  On INPUT:
//    d/dx \varphi(t,x0) \subset V \subset Vd
//  On OUTPUT
//    d/dx \varphi(t+h,x0)=V(t+h,x0) \subset Vn \subset Vdn
//    d/dx \varphi(t+[0,h],x0)=V(t+[0,h],x0) \subset Vencl=[W4] - "C^1-Lohner alg."
// IT IS NOT OBVIOUS THAT THIS IS DESIRABLE - we may want W3
//  Vrem - remainder term for the variational matrix V(h,x), before
//           the multiplication   by h^{orderV+1} (includes already
//           the multiplication  by [W3] - an enclosure for V([0,h],x))
//////  the use and meaning of other variables:
//  we represent variational matrix as
//   V_{k}  =VC_{k} + VE_{k}*V_0 + VB_k*VR_k
// then the update rule is:
//  A_{k+1,k}=A + Da; A - is a point matrix
//   V_{k+1}=A_{k+1,k}*V_k  = A*C_{k} + A*VE_k * V_0 + A_{k+1,k}*VB_k * VR_k
//                   + Da*(VC_k + VE_k*V_0)
//  if numLohnerV==LOHNER1 - interval evaluation
//     interval arithmetic evaluation of: V_{k+1}=A_{k+1,k}*V_k
//     Vc, Vcn - the only variables used
//    other variables are not used
//  numLohnerV==LOHNER3 - QR-decomposition
//    Ve,Ven,V0 - are not used
//    On input:
//       Vc + Vb*Vr \subset V
//    On output:
//       \varphi(h,Vc + Vb*Vr) \subset Vcn + Vbn*Vrn \subset Vn
//  numLohnerV==LOHNER5 - inner enclosure  with QR-decomposition
//    On input:
//      Vc + Ve*V0 + Vb*Vr \subset V
//    On output:
//       \varphi(h,Vc + Ve*V0 + Vb*Vr) \subset Vcn + Ven*V0 + Vbn*Vrn \subset Vn

{

  int ok=1;
  if(!MultiIn(x.xc,xd,0,x.sdim())){
    ok=0;
    cerr << "C1OneStepLohner - x.xc is not contained in xd, unable to continue " << endl;
    if(!x.sintersect_rep()){
      cerr << "serious error " << endl;
    }else{
      cerr << "this is not a program error of this function, the initial data are nonsistent " << endl;
    }
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    return(0);
  }

  //  PART 1A in my notes - xencl =[W_1]
  // estimation of the set xecnl,  \varphi([0,h],xd) \subset xecnl
  ok=ode.enclosure(xd,h,xencl);
  if(!ok){
    cerr << "C1OneStepLohner - bad enclosure for xd " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    return(0);
  }


  // PART 1B in my notes - ycpoint=[W_2]
  interval ycpoint[MAX_DIM+1];
  // estimation of the set ycpoint - the rough enclosure for the evolution of
           // the center point,  \varphi([0,h],x) \subset ycpoint
             // neccessary to compute the remainder
  ok=ode.enclosure(x.xc,h,ycpoint);
  if(!ok){
    cerr << "C1OneStepLohner - bad enclosure for x.xc " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    return(0);
  }



  // PART 2  - Vencl=[W_3]
  // computation of enclosure for variational part
  //  \frac{\partial \varphi}{\partial x} ([0,h],x)=V([0,h],x)
  ode.c1enclosure(h,xencl,Vencl);

  //  END of PART 2



  Vn=V;   // to copy various settings V - the data regarding the set Vn will be
           // generated and updated below; I'm not sure whether it is true
           //  maybe some parts (like the Lipschitz part) in Vn are really
           //  initiated here, it should be clarifyied in C1LohnerRearemgement, where
           // in fact this should be done


  interval *xnxc;
  xnxc=new interval[ode.dim+1];

  intervalmatrix1 *A;         // the matrix V(h,x)_ij
  A=new intervalmatrix1[ode.dim+1];
//  interval ARem[MAX_DIM+1][MAX_DIM+1]; // remainder term for V(h,x)_ij
  intervalmatrix1 *ARem;
  ARem=new intervalmatrix1[ode.dim+1];


  interval dummy[MAX_DIM+1];

  //  PART 3 - the calculation of variations
  // [W_1]=xecnl
  if (param.method==TAYLORM){
    intervalmatrix1 *dummyM;
    dummyM=new intervalmatrix1[ode.dim+1];
    dertaylor(ode,param.orderdf,h,xd,dummyM,dummy,A,0,dummyM);
    dertaylor(ode,param.orderdf,h,xencl,Vencl,dummy,dummyM,1,ARem); // ARem - the remainder term
    // for   V(h,xd)   (xd - the  enclosure for our current value of x-variable)
    // V(h,x)= d/dx (\diff_method(h,x)))=A + ARem*h^{orderV+1})
    delete [] dummyM;
  }

  if (param.method==RUNGEKUTTA){
    cerr << "Lohner for  Runge-Kutta - not ready " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  copymatrix(ARem,Vrem,ode.dim);  // VRem=ARem
  interval hto_oVp1=1.0;
  for(int i=1;i<=param.orderdf+1;i++)
    hto_oVp1*=h;

  for(int i=1;i<=ode.dim;i++)
    for(int j=1;j<=ode.dim;j++)
      A[i][j]+=ARem[i][j]*hto_oVp1;
  //  now we have:  V(h,x)=A


  if(ode.dissipative){
    intervalmatrix1 *Vstep;
    Vstep=new intervalmatrix1[ode.dim+1];
    ode.c1dissOneStep(xencl,h,Vencl,Vstep);

    if(!commonpart(A,Vstep,A,ode.dim)){
      cerr <<  "C1OneStepLohner - serious error A \\cap Vstep = \\emptyset" << endl;
      #if defined(WIN95) && defined(KRAK)
      waitBt();
      #endif
      exit(EXIT_FAILURE);
    }

    delete [] Vstep;
  }


  ArrArr(A,Vencl,Vencl,ode.dim);  // Vencl=A*Vencl - hence Vencl  becomes an
                 // enclosure for V(t_k + [0,h],x_0)
                 // IT IS NOT OBVIOUS THAT THIS IS DESIRABLE - we may want W3

  //  now we have to take into account that Vn=A*V
  C1LohnerRearrangement(V,Vn,A);
  Vn.intvencl(Vdn);  // computation of the interval enclosure  of Vn
  // end of PART 3 - the computation of variations




  // PART 4 - the computation of x
  //  [W_2]=ycpoint  - contains \varphi([0,h],x)
  if (param.method==TAYLORM){
    taylor(ode,param.order,h,x.xc,xnxc,0,dummy);   //  xn=\Phi(h,x,order)
    taylor(ode,param.order,h,ycpoint,dummy,1,rem); // the remainder term on [W_2]
  }
  interval hto_op1=1.0;
  for(int i=1;i<=param.order+1;i++)
    hto_op1*=h;

  for(int i=1;i<=ode.dim;i++)    xnxc[i]+=rem[i]*hto_op1;




  if(ode.dissipative){ // for dissipative ODE's we improve the computation
                         // of the image of the center point xc
    interval *xstep;
    xstep=new interval[ode.dim+1];
    ode.dissOneStep(x.xc,h,ycpoint,xstep,0,NULL);
    int ok=commonpart(xnxc,xstep,xnxc,ode.dim);
    if(!ok){
      char comment[]="an empty intersection of  computed bound for x(h) and rough enclosure for x(h) ";
      cerr <<  "C1OneStepLohner - serious error " << endl;
      cerr << comment << endl;
      info_err_commonpart(xnxc,xstep,ode.dim,comment);
      #if defined(WIN95) && defined(KRAK)
      waitBt();
      #endif
      exit(EXIT_FAILURE);
    }
    delete [] xstep;
  }


  // xnxc - contains now \varphi(h,x.xc)
  LohnerMove(x,xnxc,A,xn);
  // computation of xdn - set(numLohner,xn,Cn,r0,Bn,rn)
  xn.intvencl(xdn);


  // may be this is not necessary, because the dissipativeness has been already
  // taken into account in computation of the variational part and the image of
  // <xc>
  if(ode.dissipative){
    interval *xstep;
    xstep=new interval[ode.dim+1];
    ode.dissOneStep(xd,h,xencl,xstep,0,NULL);
    bool ok;
    if(param.doC0intersection){
      ok=xn.intersect_interval(xstep);   // if xn.sintersect_rep() then it also
                      // does if  necessary  a rearrangment, which will guarante
                      // that <xn.xc> is  in the interval enclosure  of <xn>
      xn.intvencl(xdn);
    }else{
      if(xn.sintersect_rep()){
        ok=commonpart(xstep,xn.enclo_intv,xn.enclo_intv,ode.dim);
        if(ok){
          copyvector(xn.enclo_intv,xdn,ode.dim);
          if(!xn.test_xc_in_encl(false)){ // we do the intersection of "Lohner set"
                                     // because xc in not in <xn.enclo>
            ok=xn.intersect_interval(xn.enclo_intv);
            xn.intvencl(xdn);
          }
        }
      }
    }
    if(!ok){
      char comment[]="an empty intersection of  computed bound for x(h) and rough enclosure for x(h) ";
      cerr <<  "C1OneStepLohner - serious error " << endl;
      cerr << comment << endl;
      info_err_commonpart(xdn,xstep,ode.dim,comment);
      #if defined(WIN95) && defined(KRAK)
      waitBt();
      #endif
      exit(EXIT_FAILURE);
    }
    /* // these are test lines
    if(!xn.test_xc_in_encl(true)){
      cerr <<  "C1OneStepLohner - warning: xc is not in enclosure " << endl;
      #if defined(WIN95) && defined(KRAK)
      waitBt();
      #endif
    }
    */

    delete [] xstep;
  }



  delete [] ARem;
  delete [] xnxc;
  delete [] A;
  return(1);
}


int C0throughC1OneStepLohner(Ode &ode,const OneStepParamType & param, interval h,
       Set &x,interval xd[],Set &xn, interval xdn[],interval xencl[],
       interval rem[])
// uses C1-Lohner algorithm  to make C0-time step, it should be
// useful in the context of dissipative ODEs
//  It does not coincide on x with the C^0-algorithm
// on INPUT : x  \subset xd
// on OUTPUT :
//       \varphi(h,x) \subset xn  \subset xdn
//    \varphi([0,h],x) \subset xencl
// rem; // remainder term in Taylor method, before the multiplication
//         by h^(param.order+1)
{
  intervalmatrix1  *Vd,*Vdn,*Vencl,*Vrem;
  Vd=new intervalmatrix1[ode.dim+1];
  Vdn=new intervalmatrix1[ode.dim+1];
  Vencl=new intervalmatrix1[ode.dim+1];
  Vrem=new intervalmatrix1[ode.dim+1];
  C1Set *V, *Vn;
  V=new C1Set(ode.dim,LOHNER1);
  V->intvencl(Vd);
  Vn=new C1Set(ode.dim,LOHNER1);
  Vn->intvencl(Vdn);
  int ret=C1OneStepLohner(ode,param,h,x,xd,xn,xdn,xencl,rem,*V, Vd,*Vn,Vdn,Vencl,Vrem);
  delete Vn;
  delete V;
  delete [] Vrem;
  delete [] Vencl;
  delete [] Vdn;
  delete [] Vd;
  return ret;
}
