#include<iostream>
// #include<fstream>
using namespace std;

#include"defo.h"
#include"metnum.h"
#include"vfkso.h"

#include"ksperiso.h"
#include"ksunst.h"



#if !defined(KSPERPAP)
#error there should be  KSPERPAP defined in defo.h
#endif



#include"mdefo.h"




void  KsInclPeriodicOrbits(KuraShi &kurashi)
{   
  cout << "---------------------------" << endl;
  cout << " 1 - attracting periodic orbit " << endl;
  cout << " 2 - unstable periodic orbit mu=0.1215, 0.1212 or mu=0.02991" << endl;

  int c;
  cin >> c;
  if((c <1) || (c>2))
    return ;

  switch(c){
    case 1: KSinclPoincareBrouwer(kurashi);break;
    case 2: KSinclunstable(kurashi);break;
  }
}


void infoAboutProofs()
{
   cout << " Here are examples of parameter choices for the proofs:" << endl;  
   cout << " we present them as pairs (mu,dim) " << endl;
   cout << " stable symmetric orbits: "<< endl;
   cout << "  (0.127 +-10^{-7}, 10),  (0.125,11), (0.032,23) " << endl;
   cout << " stable non-symmetric: (0.1215, 13) " << endl;
   cout << " unstable symmetric:  (0.1215, 11), (0.1212,14), (0.02991,25) " << endl;
   cout << " unstable non-symmetric:   (0.1212,13) " << endl;
   cout << " Other parameters will be given later in the program" << endl;
}     

int main(int /* p1*/ ,char** /* p2[]*/)
{
  #if defined(WIN95)
  init_fpunit();
  #endif


  #ifdef UP_ROUNDING
     round_up();
  #endif


  cout << " Kuramoto - Sivashinski " << endl;
  cout << " differential inclusions, proofs of periodic orbits " << endl;
  
  cout << "---------------------" << endl;
  infoAboutProofs();
  cout << "---------------------" << endl;
  
  
  int dimks=14;
  interval mu=0.127;
  ks_input_par(&mu,&dimks);

  KuraShi kurashi(dimks,mu);
  
  cout << "mu=" << mu << "  , m=dim=" << dimks << endl;

  KsInclPeriodicOrbits(kurashi);

  if(entriesinerrorlog){
    cout << "WARNING -  new entries in the error-log file ["
      << zglerrorlogname << "]" << endl;
  }
  #if defined(WIN95) && defined(KRAK)
    waitBt();
  #endif

  remove_taylor_arrays();

   #if defined(WIN95) && defined(KRAK)
    closeGW();
  #endif
  return(0);
}


